<?php

/**
* PHP version 5
*
* LICENSE: This source file is subject to version 3.0 of the PHP license
* that is available through the world-wide-web at the following URI:
* http://www.php.net/license.  If you did not receive a copy of
* the PHP License and are unable to obtain it through the web, please
* send a note to license@php.net so we can mail you a copy immediately.
*
* @package    QuickTalk
* @author     Philippe Vandenberghe <info@qt-cute.org>
* @copyright  2012 The PHP Group
* @version    3.0 build:20121228
*/

session_start();
require_once 'bin/qtf_init.php';
include Translate('qtf_adm.php');
include Translate('qtfm_antispam.php');
if ( $oVIP->user->role!='A' ) die($L['E_admin']);

// INITIALISE

$oVIP->selfurl = 'qtfm_antispam_adm.php';
$oVIP->selfname = $L['antispam']['Admin'];
$oVIP->exiturl = $oVIP->selfurl;
$oVIP->exitname = $oVIP->selfname;
$strPageversion = $L['antispam']['Version'].' 3.0<br/>';

// --------
// SUBMITTED
// --------

if ( isset($_POST['ok']) )
{
  // read settings
  if ( isset($_POST['az']) )       { $strAz    = '1'; } else { $strAz    = '0'; }
  if ( isset($_POST['vowel']) )    { $strVowel = '1'; } else { $strVowel = '0'; }
  if ( isset($_POST['chars']) )    { $strChars = '1'; } else { $strChars = '0'; }
  $strChar_n = $_POST['char_n'];
  if ( isset($_POST['words']) )    { $strWords = '1'; } else { $strWords = '0'; }
  $strWord_n = $_POST['word_n'];
  if ( isset($_POST['good']) )     { $strGood  = '1'; } else { $strGood  = '0'; }
  $strGood_n = $_POST['good_n'];
  if ( isset($_POST['insane']) )   { $strInsane= '1'; } else { $strInsane= '0'; }
  $strInsane_n = $_POST['insane_n'];
  if ( isset($_POST['repeat']) )   { $strRepeat= '1'; } else { $strRepeat= '0'; }
  if ( isset($_POST['ip']) )       { $strIp    = '1'; } else { $strIp    = '0'; }

  $str = $strAz.$strVowel.$strChars.$strChar_n.$strWords.$strWord_n.$strGood.$strGood_n.$strInsane.$strInsane_n.$strRepeat.$strIp;
  $i = $strAz+$strVowel+$strChars+$strWords+$strGood+$strInsane+$strRepeat+$strIp;

  // save settings
  $oDB->Query('UPDATE '.TABSETTING.' SET setting="'.$str.'" WHERE param="m_antispam_conf"');
  $oDB->Query('UPDATE '.TABSETTING.' SET setting="'.$i.'" WHERE param="m_antispam"');

  $_SESSION[QT]['m_antispam_conf'] = $str;
  $_SESSION[QT]['m_antispam'] = $i;

  if ( empty($strError) )
  {
    $_SESSION['pagedialog'] = (empty($error) ? 'O|'.$L['S_save'] : 'E|'.$error);
  }
}

if ( isset($_GET['a']) )
{
  if ( $_GET['a']=='default' ) $_SESSION[QT]['m_antispam_conf'] = '111211101200';
}

// --------
// HTML START
// --------

include 'qtf_adm_p_header.php';

// read values
if ( !isset($_SESSION[QT]['m_antispam_conf']) )
{
  $arr = GetParam(true,'param="m_antispam_conf"');
  if ( empty($arr) ) die('<span class="error">Parameters not found. The module is probably not installed properly.</span>');
}

if ( file_exists('avatar/qtfm_ip.php') ) { include 'avatar/qtfm_ip.php'; } else { $arrIp=array(); }

$strAz       = substr($_SESSION[QT]['m_antispam_conf'],0,1);
$strVowel    = substr($_SESSION[QT]['m_antispam_conf'],1,1);
$strChars    = substr($_SESSION[QT]['m_antispam_conf'],2,1);
$strChar_n   = substr($_SESSION[QT]['m_antispam_conf'],3,1);
$strWords    = substr($_SESSION[QT]['m_antispam_conf'],4,1);
$strWord_n   = substr($_SESSION[QT]['m_antispam_conf'],5,1);
$strGood     = substr($_SESSION[QT]['m_antispam_conf'],6,1);
$strGood_n   = substr($_SESSION[QT]['m_antispam_conf'],7,1);
$strInsane   = substr($_SESSION[QT]['m_antispam_conf'],8,1);
$strInsane_n = substr($_SESSION[QT]['m_antispam_conf'],9,1);
$strRepeat   = substr($_SESSION[QT]['m_antispam_conf'],10,1);
$strIp       = substr($_SESSION[QT]['m_antispam_conf'],11,1);

// FORM

echo '<form method="post" action="',$oVIP->selfurl,'">
<h2 class="subtitle">',$L['antispam']['Basic_rules'],'</h2>
<table class="data_o">
<tr class="data_o">
<td class="headfirst" style="width:30px"><input type="checkbox" id="az" name="az"',($strAz=='1' ? QCHE : ''),'/></td>
<td><label for="az">',$L['antispam']['Az'],'</label></td>
</tr>
<tr class="data_o">
<td class="headfirst" style="width:30px"><input type="checkbox" id="vowel" name="vowel"',($strVowel=='1' ? QCHE : ''),'/></td>
<td><label for="vowel">',$L['antispam']['Voyelles'],'</label></td>
</tr>
<tr class="data_o">
<td class="headfirst" style="width:30px"><input type="checkbox" id="chars" name="chars"',($strChars=='1' ? QCHE : ''),'/></td>
<td><label for="chars">',$L['antispam']['Chars'],'</label>&nbsp;
<select name="char_n" size="1">
<option value="1"',($strChar_n=='1' ? QSEL : ''),'>',$L['antispam']['Char_1'],'</option>
<option value="2"',($strChar_n=='2' ? QSEL : ''),'>',$L['antispam']['Char_2'],'</option>
<option value="3"',($strChar_n=='3' ? QSEL : ''),'>',$L['antispam']['Char_3'],'</option>
<option value="4"',($strChar_n=='4' ? QSEL : ''),'>',$L['antispam']['Char_4'],'</option>
</select></td>
</tr>
<tr class="data_o">
<td class="headfirst" style="width:30px"><input type="checkbox" id="words" name="words"',($strWords=='1' ? QCHE : ''),'/></td>
<td><label for="words">',$L['antispam']['Words'],'</label>
<select name="word_n" size="1">
<option value="1"',($strWord_n=='1' ? QSEL : ''),'>',$L['antispam']['Word_1'],'</option>
<option value="2"',($strWord_n=='2' ? QSEL : ''),'>',$L['antispam']['Word_2'],'</option>
<option value="3"',($strWord_n=='3' ? QSEL : ''),'>',$L['antispam']['Word_3'],'</option>
</select></td>
</tr>
</table>
';
echo '<h2 class="subtitle">',$L['antispam']['Content_checking_rules'],'</h2>
<table class="data_o">
<tr class="data_o">
<td class="headfirst" style="width:30px"><input type="checkbox" id="good" name="good"',($strGood=='1' ? QCHE : ''),'/></td>
<td><label for="good">',$L['antispam']['Langue'],'</label>
<select name="good_n" size="1">
<option value="0"',($strGood_n=='0' ? QSEL : ''),'>',$L['antispam']['Langue_0'],'</option>
<option value="1"',($strGood_n=='1' ? QSEL : ''),'>',$L['antispam']['Langue_1'],'</option>
</select></td>
</tr>
<tr class="data_o">
<td class="headfirst" style="width:30px"><input type="checkbox" id="insane" name="insane"',($strInsane=='1' ? QCHE : ''),'/></td>
<td><label for="insane">',$L['antispam']['Insane'],'</label>
<select name="insane_n" size="1">
<option value="1"',($strInsane_n=='1' ? QSEL : ''),'>',$L['antispam']['Insane_1'],'</option>
<option value="2"',($strInsane_n=='2' ? QSEL : ''),'>',$L['antispam']['Insane_2'],'</option>
</select></td>
</tr>
</table>
';
echo '
<h2 class="subtitle">',$L['antispam']['Activity_check'],'</h2>
<table class="data_o">
<tr class="data_o">
<td class="headfirst" style="width:30px"><input type="checkbox" id="repeat" name="repeat"',($strRepeat=='1' ? QCHE : ''),'/></td>
<td><label for="repeat">',$L['antispam']['Repeat'],'</label></td>
</tr>
<tr class="data_o">
<td class="headfirst" style="width:30px"><input type="checkbox" id="ip" name="ip"',($strIp=='1' ? QCHE : ''),'/></td>
<td><label for="ip">',$L['antispam']['Reject_ip'],'</label>';
if ( isset($arrIp) )
{
echo '&nbsp;<a href="qtfm_antispam_admip.php">',sprintf($L['antispam']['Banned_ip'],count($arrIp)),'</a>';
}
echo '</td>
</tr>
</table>
';
echo '<p class="submit">
<a href="',$oVIP->selfurl,'?a=default" style="font-weight:normal;">',$L['antispam']['Default'],'</a>&nbsp;&middot;&nbsp;<input type="submit" name="ok" value="',$L['Save'],'"/>
</p>
</form>
';

// HTML END

include 'qtf_adm_p_footer.php';