<?php

/**
* PHP version 5
*
* LICENSE: This source file is subject to version 3.0 of the PHP license
* that is available through the world-wide-web at the following URI:
* http://www.php.net/license.  If you did not receive a copy of
* the PHP License and are unable to obtain it through the web, please
* send a note to license@php.net so we can mail you a copy immediately.
*
* @package    QuickTalk
* @author     Philippe Vandenberghe <info@qt-cute.org>
* @copyright  2012 The PHP Group
* @version    3.0 build:20121228
*/

session_start();
require_once 'bin/qtf_init.php';
include Translate('qtf_adm.php');
include Translate('qtfm_antispam.php');
if ( $oVIP->user->role!='A' ) die($L['E_admin']);

// INITIALISE

$oVIP->selfurl = 'qtfm_antispam_admip.php';
$oVIP->selfname = $L['antispam']['Admin'];
$oVIP->exiturl = 'qtfm_antispam_adm.php';
$oVIP->exitname = '&laquo; '.$oVIP->selfname;
$strPageversion = $L['antispam']['Version'].' 3.0<br/>';

// --------
// SUBMITTED
// --------

if ( isset($_POST['add_ok']) )
{
  $str = trim($_POST['newip']);
  if ( !preg_match('/^([0-9]{1,3})\.([0-9]{1,3})\.([0-9]{1,3})\.(\*|([0-9]{1,3}))(.*)/',$str) ) $error = 'Invalid IP';

  if ( empty($error) )
  {
    if ( file_exists('avatar/qtfm_ip.php') ) include 'avatar/qtfm_ip.php';
    // read ip
    $arrStr = explode(' ',$str,2);
    if ( count($arrStr)==1 ) { $arrIp[$arrStr[0]]=' '; } else { $arrIp[$arrStr[0]]=$arrStr[1]; }
    // save new list
    $intHandle = fopen('avatar/qtfm_ip.php','w');
    fwrite($intHandle,"<?php\n\$arrIp=array();\n");
    foreach($arrIp as $strKey=>$strValue)
    {
    fwrite($intHandle,"\$arrIp['$strKey']='$strValue';\n");
    }
    fwrite($intHandle,"\n?>");
    fclose($intHandle);
  }
}

if ( isset($_POST['rem_ok']) )
{
  if ( !empty($_POST['ip']) )
  {
    // rem ip
    if ( file_exists('avatar/qtfm_ip.php') ) include 'avatar/qtfm_ip.php';
    if ( array_key_exists($_POST['ip'],$arrIp) )
    {
    unset($arrIp[$_POST['ip']]);
    }
    // save new list
    $intHandle = fopen('avatar/qtfm_ip.php','w');
    fwrite($intHandle,"<?php\n\$arrIp=array();\n");
    foreach($arrIp as $strKey=>$strValue)
    {
    fwrite($intHandle,"\$arrIp['$strKey']='$strValue';\n");
    }
    fwrite($intHandle,"\n?>");
    fclose($intHandle);
  }
}

if ( isset($_POST['all_ok']) )
  {
    $intHandle = fopen('avatar/qtfm_ip.php','w');
    fwrite($intHandle,"<?php\n\$arrIp=array();\n?>");
    fclose($intHandle);
  }

// --------
// HTML START
// --------

if ( file_exists('avatar/qtfm_ip.php') ) include 'avatar/qtfm_ip.php';

include 'qtf_adm_p_header.php';

echo '<form method="post" action="',$oVIP->selfurl,'">
<h2 class="subtitle">',$L['antispam']['Reject_ip'],'</h2>
<table class="data_o">
<tr class="data_o">
<td class="headfirst" style="width:100px">IP</td>
<td><select id="ip" name="ip" size="10" style="width:400px">';
foreach($arrIp as $strKey=>$strValue)
{
echo  '<option value="',$strKey,'">',$strKey,'&nbsp;&nbsp;',$strValue,'</option>',PHP_EOL;
}
echo '</select><br/>';
if ( count($arrIp)>0 )
{
echo '<input type="submit" id="rem_ok" name="rem_ok" value="',$L['Remove'],'"/>&nbsp;';
if ( count($arrIp)>1 ) echo '<input type="submit" id="all_ok" name="all_ok" value="',$L['antispam']['Remove_all'],'"/>';
}
echo '</td>
</tr>
';
echo '<tr class="data_o">
<td class="headfirst" style="width:100px">',$L['Edit'],' *</td>
<td>
<input type="text" id="newip" name="newip" style="width:350px" maxlength="64"/>
<input type="submit" id="add_ok" name="add_ok" value="',$L['Add'],'"/>
</td>
</tr>
';
echo '<tr class="data_o">
<td class="blanko" colspan="2">* <span class="small">',$L['antispam']['H_Ip'],'</span></td>
</tr>
</table>
</form>
<p><a href="',$oVIP->exiturl,'">',$oVIP->exitname,'</a></p>
';

// HTML END

include 'qtf_adm_p_footer.php';