<?php

/**
 * PHP version 5
 *
 * LICENSE: This source file is subject to version 3.0 of the PHP license
 * that is available through the world-wide-web at the following URI:
 * http://www.php.net/license.  If you did not receive a copy of
 * the PHP License and are unable to obtain it through the web, please
 * send a note to license@php.net so we can mail you a copy immediately.
 *
 * @package    QuickTalk
 * @author     Philippe Vandenberghe <info@qt-cute.org>
 * @copyright  2012 The PHP Group
 * @version    3.0 build:20121228
 */

session_start();
require_once 'bin/qtf_init.php';
include Translate('qtf_adm.php');
if ( $oVIP->user->role!='A' ) die($L['E_admin']);

// INITIALISE

$strVersion='v3.0';
$oVIP->selfurl = 'qtfm_antispam_install.php';
$oVIP->selfname = 'Installation module ANTISPAM '.$strVersion;

$bStep0 = true;
$bStep1 = true;
$bStep2 = true;
if ( isset($_SESSION[QT]['m_antispam']) ) unset($_SESSION[QT]['m_antispam']);
if ( isset($_SESSION[QT]['m_antispam_conf']) ) unset($_SESSION[QT]['m_antispam_conf']);

// STEP 0: check version

$strQTF = QTFVERSION; if ( substr(QTFVERSION,0,1)=='v') $strQTF = substr(QTFVERSION,1);
$arrQTF = explode('.',$strQTF);
if ( intval($arrQTF[0])<2 ) $error="Your QuickTalk version is $strQTF. Please, upgrade to QuickTalk 2.0 before installing this module...";
if ( !empty($error) ) $bStep0 = false;

// STEP 1

if ( empty($error) )
{
  $strFile = 'qtfm_antispam.php';
  if ( !file_exists($strFile) ) $error="Missing file: $strFile<br/>This module cannot be used.";
  $strFile = 'qtfm_antispam_adm.php';
  if ( !file_exists($strFile) ) $error="Missing file: $strFile<br/>This module cannot be used.";
  $strFile = 'qtfm_antispam_admip.php';
  if ( !file_exists($strFile) ) $error="Missing file: $strFile<br/>This module cannot be used.";
  $strFile = 'qtfm_antispam_uninstall.php';
  if ( !file_exists($strFile) ) $error="Missing file: $strFile<br/>This module cannot be used.";
  if ( !empty($error) ) $bStep1 = false;
}

// INSTALL

if ( empty($error) )
{
  $oDB->Query('DELETE FROM '.TABSETTING.' WHERE param="module_antispam" OR param="m_antispam" OR param="m_antispam_conf"');
  $oDB->Query('INSERT INTO '.TABSETTING.' (param,setting,loaded) VALUES ("module_antispam","Antispam","1")');
  $oDB->Query('INSERT INTO '.TABSETTING.' (param,setting,loaded) VALUES ("m_antispam","0","1")');
  $oDB->Query('INSERT INTO '.TABSETTING.' (param,setting,loaded) VALUES ("m_antispam_conf","V 2.0 3","1")');
  $_SESSION[QT]['module_antispam'] = 'Antispam';
  $_SESSION[QT]['m_antispam'] = 0;
  $_SESSION[QT]['m_antispam_conf'] = 'V 2.0 3';
}

// STEP 2

if ( empty($error) )
{
  $intHandle = fopen('avatar/qtfm_ip.php','w');
  if ( !$intHandle ) $error="Impossible to create the file [avatar/qtfm_ip.php]. Check that the folder /avatar/ is writable (chmod 777).";
}
if ( empty($error) )
{
  if ( fwrite($intHandle,"<?php\n\$arrIp=array();\n?>")===FALSE ) $error='Impossible to write in the file [avatar/qtfm_ip.php].';
  fclose($intHandle);
}
if ( !empty($error) ) $bStep2 = false;

// --------
// Html start
// --------

include 'qtf_adm_p_header.php';

if ( !$bStep0 )
{
  echo '<p class="error">',$error,'</p>';
  include 'qtf_adm_p_footer.php';
  exit;
}

echo '<h2>Checking components</h2>';
if ( !$bStep1 )
{
  echo '<p class="error">',$error,'</p>';
  include 'qtf_adm_p_footer.php';
  exit;
}
echo '<p>Ok</p>';

echo '<h2>Database settings</h2>';
echo '<p>Ok</p>';

echo '<h2>Creating file for IP</h2>';
if ( !$bStep2 )
{
  echo '<p class="error">',$error,'</p>';
}
echo '<p>Ok</p>';

echo '<h2>Installation completed</h2>';

echo '<p><a href="qtfm_antispam_adm.php">Configure...</a></p>';

// --------
// Html end
// --------

include 'qtf_adm_p_footer.php';