<?php
/**
* PHP version 5
*
* LICENSE: This source file is subject to version 3.0 of the PHP license
* that is available through the world-wide-web at the following URI:
* http://www.php.net/license. If you did not receive a copy of
* the PHP License and are unable to obtain it through the web, please
* send a note to license@php.net so we can mail you a copy immediately.
*
* @package    QuickTalk
* @author     Philippe Vandenberghe <info@qt-cute.org>
* @copyright  2012 The PHP Group
* @version    3.0 build:20121228
*/

session_start();
require_once 'bin/qtf_init.php';
if ( $oVIP->user->role!='A' ) die('Access is restricted to administrators only');
include Translate('qtf_adm.php');
include 'qtfm_ldap_lib.php';

// INITIALISE

$tt=0;
$oVIP->selfurl = 'qtfm_ldap_adm.php';
$oVIP->selfname = 'LDAP stettings';
$oVIP->exiturl = 'qtf_adm_secu.php';

QThttpvar('tt','int');
if ( $tt<0 || $tt>2) $tt=0;

if ( !isset($_SESSION[QT]['m_ldap']) ) $_SESSION[QT]['m_ldap']='0';
if ( !isset($_SESSION[QT]['login_addon']) ) $_SESSION[QT]['login_addon']='0';

// --------
// SUBMITTED
// --------

if ( isset($_POST['ok']) && $tt==0 )
{
  $oDB->Query('DELETE FROM '.TABSETTING.' WHERE param="m_ldap" OR param="m_ldap_users"');

  $_SESSION[QT]['m_ldap_users'] = $_POST['m_ldap_users']; if ( $_SESSION[QT]['m_ldap_users']!=='ldap' ) $_SESSION[QT]['m_ldap_users']='all';
  $oDB->Query('INSERT INTO '.TABSETTING.' VALUES ("m_ldap_users","'.$_SESSION[QT]['m_ldap_users'].'","1")');

  // Enable module (m_ldap=0 means disable, m_ldap=qtfm_ldap_login.php means enabled
  $_SESSION[QT]['m_ldap']='0';
  if ( $_POST['m_ldap']=='1' )
  {
    if ( empty($_SESSION[QT]['m_ldap_host']) ) $error = 'First defined Ldap settings';
    if ( !function_exists('ldap_connect') ) $error = 'Ldap function not found, unable to start the module.';
    if ( empty($error) ) $_SESSION[QT]['m_ldap']='1';

  }
  $oDB->Query('INSERT INTO '.TABSETTING.' VALUES ("m_ldap","'.$_SESSION[QT]['m_ldap'].'","1")');

  // exit
  $_SESSION['pagedialog'] = (empty($error) ? 'O|'.$L['S_save'] : 'E|'.$error);
}

if ( isset($_POST['ok']) && $tt>0 )
{
  // register value used
  $_SESSION[QT]['m_ldap_host'] = $_POST['m_ldap_host'];
  $_SESSION[QT]['m_ldap_login_dn'] = $_POST['m_ldap_login_dn'];
  $_SESSION[QT]['m_ldap_bind'] = (isset($_POST['m_ldap_bind']) ? 'a' : 'n');
  $_SESSION[QT]['m_ldap_bind_rdn'] = '';
  $_SESSION[QT]['m_ldap_bind_pwd'] = '';
  if ( $_SESSION[QT]['m_ldap_bind']==='n' && !empty($_POST['m_ldap_bind_rdn']) ) $_SESSION[QT]['m_ldap_bind_rdn'] = $_POST['m_ldap_bind_rdn'];
  if ( $_SESSION[QT]['m_ldap_bind']==='n' && !empty($_POST['m_ldap_bind_pwd']) ) $_SESSION[QT]['m_ldap_bind_pwd'] = $_POST['m_ldap_bind_pwd'];
  $_SESSION[QT]['m_ldap_s_rdn'] = (empty($_POST['m_ldap_s_rdn']) ? '' : $_POST['m_ldap_s_rdn']);
  $_SESSION[QT]['m_ldap_s_filter'] = (empty($_POST['m_ldap_s_filter']) ? '' : $_POST['m_ldap_s_filter']);
  $_SESSION[QT]['m_ldap_s_info'] = (empty($_POST['m_ldap_s_info']) ? '' : $_POST['m_ldap_s_info']);

  // Save
  if ( $tt>0 )
  {
    $oDB->Query('DELETE FROM '.TABSETTING.' WHERE param="m_ldap_host" OR param="m_ldap_login_dn" OR param="m_ldap_bind" OR param="m_ldap_bind_rdn" OR param="m_ldap_bind_pwd" OR param="m_ldap_s_rdn" OR param="m_ldap_s_filter" OR param="m_ldap_s_info"');
    $oDB->Query('INSERT INTO '.TABSETTING.' VALUES ("m_ldap_host","'.$_SESSION[QT]['m_ldap_host'].'","1")');
    $oDB->Query('INSERT INTO '.TABSETTING.' VALUES ("m_ldap_login_dn","'.$_SESSION[QT]['m_ldap_login_dn'].'","1")');
    $oDB->Query('INSERT INTO '.TABSETTING.' VALUES ("m_ldap_bind","'.$_SESSION[QT]['m_ldap_bind'].'","1")');
    $oDB->Query('INSERT INTO '.TABSETTING.' VALUES ("m_ldap_bind_rdn","'.$_SESSION[QT]['m_ldap_bind_rdn'].'","1")');
    $oDB->Query('INSERT INTO '.TABSETTING.' VALUES ("m_ldap_bind_pwd","'.$_SESSION[QT]['m_ldap_bind_pwd'].'","1")');
    $oDB->Query('INSERT INTO '.TABSETTING.' VALUES ("m_ldap_s_rdn","'.$_SESSION[QT]['m_ldap_s_rdn'].'","1")');
    $oDB->Query('INSERT INTO '.TABSETTING.' VALUES ("m_ldap_s_filter","'.$_SESSION[QT]['m_ldap_s_filter'].'","1")');
    $oDB->Query('INSERT INTO '.TABSETTING.' VALUES ("m_ldap_s_info","'.$_SESSION[QT]['m_ldap_s_info'].'","1")');
    // exit
    $_SESSION['pagedialog'] = (empty($error) ? 'O|'.$L['S_save'] : 'E|'.$error);
  }

  // Test
  if ( $tt==2 )
  {
    $test_conn='<span style="color:red">pending</span>';
    $test_find='<span style="color:red">pending</span>';
    $test_login='<span style="color:red">pending</span>';

    if ( empty($_SESSION[QT]['m_ldap_host']) ) $error='Missing host';
    if ( empty($_SESSION[QT]['m_ldap_login_dn']) ) $error='Missing login dn';

    $username = $_POST['username']; if ( get_magic_quotes_gpc() ) $username = stripslashes($username);
    $password = $_POST['password']; if ( get_magic_quotes_gpc() ) $password = stripslashes($username);
    if ( empty($username) ) $error='Missing username';

    $step=0; // steps of the test
    $intEntries=0;

    // open connection
    if ( empty($error) )
    {
      $step++;
      $c = @ldap_connect($_SESSION[QT]['m_ldap_host']) or $error=ldap_err2str(ldap_errno($c));
    }
    // admin(anonymous) bind
    if ( empty($error) )
    {
      $step++;
      $test_conn='<span style="color:green">started</span>';
      $test_find='<span style="color:red">failed</span>';
      $test_login='<span style="color:red">access denied</span>';
      ldap_set_option($c, LDAP_OPT_PROTOCOL_VERSION, 3);
      ldap_set_option($c, LDAP_OPT_REFERRALS, 0);
      if ( $_SESSION[QT]['m_ldap_bind']==='n' )
      {
        @ldap_bind($c,$_SESSION[QT]['m_ldap_bind_rdn'],$_SESSION[QT]['m_ldap_bind_pwd']) or $error='Connection result: '.ldap_err2str(ldap_errno($c)); // bind (anonymous by default)
      }
      else
      {
        @ldap_bind($c) or $error='Connection result: '.ldap_err2str(ldap_errno($c)); // bind (anonymous by default)
      }
    }
    // search test user
    if ( empty($error) )
    {
      $step++;
      $filter = str_replace('$username',$username,$_SESSION[QT]['m_ldap_s_filter']);
      $s = @ldap_search($c,$_SESSION[QT]['m_ldap_s_rdn'],$filter,explode(',',$_SESSION[QT]['m_ldap_s_info'])) or $error='Search result: '.ldap_err2str(ldap_errno($c));
    }
    // analyse search results
    if ( empty($error) )
    {
      $step++;
      $intEntries = ldap_count_entries($c,$s);
      $test_find='<span style="color:green">'.$intEntries.' matching entry</span>';
      $users = ldap_get_entries($c, $s);
      $infos = explode(',',$_SESSION[QT]['m_ldap_s_info']);
      $results = array();
      for($i=0;$i<$intEntries;$i++)
      {
        $results[$i] = '';
        foreach($infos as $info)
        {
          if ( isset($users[$i][$info]) ) { $results[$i] .= $info.'='.$users[$i][$info][0].','; } else { $results[$i] .= '(missing '.$info.'),'; }
        }
        if ( $i>=1 ) { $results[]='...'; break; }
      }
      if ( $intEntries>0 ) $test_find .= '<br/><span class="small">&gt; '.implode('<br/>&gt; ',$results).'</span>';
    }
    // bind test user
    if ( empty($error) )
    {
      $step++;
      $b = qtfm_ldap_bind($username,$password);
      if ( $b )
      {
        $test_login='<span style="color:green">successfull</span>';
      }
      else
      {
        $test_login='<span style="color:red">denied</span>';
        $test_login.='<br/><span class="small" style="color:red">&gt; '.$error.'<br/>&gt; Possible cause: '.($intEntries==0 ? 'the username does not exists (or is not in the group specied by the login DN)' : 'username exists but the password is invalid') .'</span>';
      }
    }
    if ( $step>0 ) ldap_close($c);

    // exit
    $_SESSION['pagedialog'] = (empty($error) ? 'O|Test completed' : 'E|'.$error);
  }
}

// --------
// HTML START
// --------

if ( !isset($_SESSION[QT]['m_ldap_host']) ) $_SESSION[QT]['m_ldap_host']='';
if ( !isset($_SESSION[QT]['m_ldap_login_dn']) ) $_SESSION[QT]['m_ldap_login_dn']='';
if ( !isset($_SESSION[QT]['m_ldap_bind']) ) $_SESSION[QT]['m_ldap_bind']='a';
if ( !isset($_SESSION[QT]['m_ldap_bind_rdn']) ) $_SESSION[QT]['m_ldap_bind_rdn']='';
if ( !isset($_SESSION[QT]['m_ldap_bind_pwd']) ) $_SESSION[QT]['m_ldap_bind_pwd']='';
if ( !isset($_SESSION[QT]['m_ldap_s_rdn']) ) $_SESSION[QT]['m_ldap_s_rdn']='';
if ( !isset($_SESSION[QT]['m_ldap_s_filter']) ) $_SESSION[QT]['m_ldap_s_filter']='';
if ( !isset($_SESSION[QT]['m_ldap_s_info']) ) $_SESSION[QT]['m_ldap_s_info']='mail';
if ( !isset($_SESSION[QT]['m_ldap_users']) ) $_SESSION[QT]['m_ldap_users']='all';

$oHtml->scripts[] = '<script type="text/javascript">
<!--
function ToggleAnonymous(checked)
{
  var doc = document.getElementById("bind_input");
  if ( doc ) doc.style.display=(checked ? "none" : "block");
}
//-->
</script>
';

include 'qtf_adm_p_header.php';

// DISPLAY TABS

$arrTabs = array('Authority','Settings','Test');
echo HtmlTabs($arrTabs, $oVIP->selfurl.'?', $tt, 6, $L['E_editing']);

// DISPLAY TAB PANEL

echo '<div class="pan">
<div class="pan_top">',$arrTabs[$tt],'</div>
';

if ( !function_exists('ldap_connect') ) echo '<p class="error">LDAP function not found. It seems that module LDAP is not activated on your webserver.</p>';

if ( $tt==0 )
{

if ( $_SESSION[QT]['login_addon']==='0')
{
echo '<p class="small">Current authority is <span class="bold italic">Internal authority (default)</span>.<br/>When module is on-line, change the authority from the page '.L('Adm_security').'.</p>';
}
echo '<form method="post" action="',Href(),'">
<h2 class="subtitle">Module status</h2>
<table class="data_o">
<tr class="data_o">
<td class="headfirst">Status</td>
';

if ($_SESSION[QT]['m_ldap']=='1')
{
  echo '<td style="background-color:#AAFFAA;width:120px;text-align:center"><b>',L('On_line'),'</b></td>';
}
else
{
  echo '<td style="background-color:#FFAAAA;width:120px;text-align:center"><b>',L('Off_line'),'</b></td>';
}
echo '<td style="text-align:right">',$L['Change'],'&nbsp;
<select id="m_ldap" name="m_ldap">
<option value="1"',($_SESSION[QT]['m_ldap']=='1' ? QSEL : ''),'>',$L['On_line'],'</option>
<option value="0"',($_SESSION[QT]['m_ldap']=='0' ? QSEL : ''),'>',$L['Off_line'],'</option>
</select>
</td>
</tr>
</table>

<h2 class="subtitle">User authentication</h2>
<table class="data_o">
<tr class="data_o">
<td class="headfirst">Login users</td>
<td>
<input type="radio" id="log_all" name="m_ldap_users" value="all"',($_SESSION[QT]['m_ldap_users']=='all' ? QCHE : ''),'/><label for="log_all">Accept locally registered users AND ldap users</label><br/>
<input type="radio" id="log_ldap" name="m_ldap_users" value="ldap"',($_SESSION[QT]['m_ldap_users']=='ldap' ? QCHE : ''),'/><label for="log_ldap">Accept ONLY valid ldap users</label>
</td>
</tr>
';
echo '<tr class="data_o">
<td class="headfirst">',L('Information'),'</td>
<td>
<p class="small"><span class="bold italic">Accept locally registered users AND ldap account</span><br/>
With this option, users without ldap entry must first register before using the application. Users having a valid ldap account don\'t need to register.</p>
<p class="small"><span class="bold italic">Accept ONLY valid ldap accounts</span><br/>
On first login, a local profile is created for the user having a valid ldap account.<br/>
For users without ldap account, the register page allows sending a request to the Administrator in order to create a new ldap entry.<br/>
With this option, it\'s recommanded to turn the registration mode to "backoffice" (see security page).</p>
</td>
</tr>
</table>
';
}

if ( $tt==1 || $tt==2 )
{
echo '<form method="post" action="',Href(),'">
<h2 class="subtitle">Connection and authentication</h2>
<table class="data_o">
<tr class="data_o">
<td class="headfirst">Host</td>
<td><input type="text" id="m_ldap_host" name="m_ldap_host" size="32" maxlength="64" value="',$_SESSION[QT]['m_ldap_host'],'"/></td>
<td><span class="small">Host and port. Example </span><span class="small" style="color:#4444ff">ldap://localhost:10389</span></td>
</tr>
<tr class="data_o">
<td class="headfirst">Login DN</td>
<td><input type="text" id="m_ldap_login_dn" name="m_ldap_login_dn" size="32" maxlength="64" value="',$_SESSION[QT]['m_ldap_login_dn'],'"/></td>
<td><span class="small">Use $username as placeholder. Example </span><span class="small" style="color:#4444ff">cn=$username,ou=users,o=mycompany</span></td>
</tr>
</table>
';
echo '<h2 class="subtitle">Search configuration (to create new user)</h2>
<table class="data_o">
<tr class="data_o">
<td class="headfirst" style="vertical-align:top">When searching</td>
<td style="vertical-align:top"><span class="small"><input type="checkbox" id="m_ldap_bind" name="m_ldap_bind" value="a"'.($_SESSION[QT]['m_ldap_bind']==='a' ? QCHE : '').' onclick="ToggleAnonymous(this.checked);"/>Server supports anonymous bind</span></td>
<td style="vertical-align:top">
<div id="bind_input" style="display:'.($_SESSION[QT]['m_ldap_bind']==='a' ? 'none' : 'block').'">
<span class="small"><input type="text" id="m_ldap_bind_rdn" name="m_ldap_bind_rdn" size="25" maxlength="34" value="',$_SESSION[QT]['m_ldap_bind_rdn'],'"/>&nbsp;System DN<br/>
<input type="text" id="m_ldap_bind_pwd" name="m_ldap_bind_pwd" size="25" maxlength="64" value="',$_SESSION[QT]['m_ldap_bind_pwd'],'"/>&nbsp;Password</span>
</div>
</td>
</tr>
<tr class="data_o">
<td class="headfirst">Search RDN</td>
<td><input type="text" id="m_ldap_s_rdn" name="m_ldap_s_rdn" size="32" maxlength="64" value="',$_SESSION[QT]['m_ldap_s_rdn'],'"/></td>
<td><span class="small">dn or rdn (search basis)</span></td>
</tr>
<tr class="data_o">
<td class="headfirst">Search filter</td>
<td><input type="text" id="m_ldap_s_filter" name="m_ldap_s_filter" size="32" maxlength="64" value="',$_SESSION[QT]['m_ldap_s_filter'],'"/></td>
<td><span class="small">Use $username as placeholder. Example </span><span class="small" style="color:#4444ff">(cn=$username)</span><span class="small"> allows searching the username specified in the login panel</span></td>
</tr>
<tr class="data_o">
<td class="headfirst">Requested info</td>
<td><input type="text" id="m_ldap_s_info" name="m_ldap_s_info" size="32" maxlength="64" value="',$_SESSION[QT]['m_ldap_s_info'],'"/></td>
<td><span class="small">At least the mail is recommended. This is usefull when a user performs his very first login (the application will create a new profile with the same e-mail as in ldap).</span></td>
</tr>
</table>
';
}

if ( $tt==2  )
{

if ( !isset($test_conn) ) $test_conn='<span class="disabled">(none)</span>';
if ( !isset($test_find) ) $test_find='<span class="disabled">(none)</span>';
if ( !isset($test_login) ) $test_login='<span class="disabled">(none)</span>';

echo '<h2 class="subtitle">Test</h2>
<table class="data_o">
<tr class="data_o">
<td class="headfirst">Username</td>
<td><input type="text" id="username" name="username" size="32" maxlength="64" value=""/></td>
</tr>
<tr class="data_o">
<td class="headfirst">Password</td>
<td><input type="text" id="password" name="password" size="32" maxlength="64" value=""/></td>
</tr>
<tr class="data_o">
<td class="headfirst">Test result</td>
<td>Connection: ',$test_conn,'<br/>Search user: ',$test_find,'<br/>Login: ',$test_login,'<br/></td>
</tr>
</table>
';
}

echo '<p class="submit">',PHP_EOL;
if ( $tt==2 )
{
  if ( function_exists('ldap_connect') )
  {
  echo '<input type="hidden" name="tt" value="',$tt,'"/><input type="submit" name="ok" value="Test"/></p>',PHP_EOL;
  }
  else
  {
  echo 'LDAP function not found. It seems that module LDAP is not activated on your webserver.
  ';
  }
}
else
{
echo '<p class="submit">
<input type="hidden" name="tt" value="',$tt,'"/>
<input type="submit" name="ok" value="',$L['Save'],'"/>

';
}

echo '</p>
</form>
';

// END TABS

echo '
</div>
';

echo '<p><a href="',$oVIP->exiturl,'" onclick="return qtEdited(bEdited,\''.$L['E_editing'].'\');">',$oVIP->exitname,'</a></p>';

// INFO
if ( $tt>0 )
{
echo '<br/>
<h2 class="subtitle">Setting examples</h2>
<table class="hidden" style="width:500px">
<tr class="hidden">
<td class="hidden">
<div class="scrollmessage">
<p>
Host <span style="color:#4444ff">ldap://localhost:10389</span><br/>
Login DN <span style="color:#4444ff">uid=$username,dc=example,dc=com</span><br/>
Search RDN <span style="color:#4444ff">dc=example,dc=com</span><br/>
Search filter <span style="color:#4444ff">(cn=$username)</span><br/>
Requested info <span style="color:#4444ff">cn,sn,mail,uid</span><br/>
</p>
';
echo '<p class="bold">Example with url and ssl</p>
<p class="small">If you are using OpenLDAP 2.x.x you can specify a URL instead of the hostname. To use LDAP with SSL, compile OpenLDAP 2.x.x with SSL support, configure PHP with SSL, and set this parameter as ldaps://hostname/.</p>
<p class="small">
Host <span style="color:#4444ff">ldaps://ldap.example.com</span> (port not used when using URLs)<br/>
Login DN <span style="color:#4444ff">cn=$username,ou=users,o=mycompany</span><br/>
Search RDN <span style="color:#4444ff">ou=users,o=mycompany</span><br/>
Search filter <span style="color:#4444ff">(uid=$username)</span><br/>
Requested info <span style="color:#4444ff">cn,sn,mail,uid</span><br/>
</p>
</div>
</td>
</tr>
</table>
';
}

// HTML END

include 'qtf_adm_p_footer.php';