<?php

/**
 * PHP version 5
 *
 * LICENSE: This source file is subject to version 3.0 of the PHP license
 * that is available through the world-wide-web at the following URI:
 * http://www.php.net/license.  If you did not receive a copy of
 * the PHP License and are unable to obtain it through the web, please
 * send a note to license@php.net so we can mail you a copy immediately.
 *
 * @package    QuickTalk
 * @author     Philippe Vandenberghe <info@qt-cute.org>
 * @copyright  2012 The PHP Group
 * @version    3.0 build:20121228
 */

session_start();
require_once 'bin/qtf_init.php';
include Translate('qtf_adm.php');
if ( $oVIP->user->role!='A' ) die($L['E_admin']);

// INITIALISE

$strVersion='v3.0';

$oVIP->selfurl = 'qtfm_map_install.php';
$oVIP->selfname = 'Installation module MAP '.$strVersion;

$bStep1 = true;
$bStepZ = true;

// STEP 1

foreach(array('qtfm_map_uninstall.php','qtfm_map_adm.php','qtfm_map_load.php','qtfm_map_lib.php') as $strFile)
{
if ( !file_exists($strFile) ) $error='Missing file: '.$strFile.'<br/>This module cannot be used.';
}
if ( !empty($error) ) $bStep1 = false;

// STEP Z
if ( empty($error) )
{
  $_SESSION[QT]['module_map'] = 'Map';
  $_SESSION[QT]['m_map_gkey'] = '';
  $_SESSION[QT]['m_map_gcenter'] = '50.8468142558,4.35238838196';
  $_SESSION[QT]['m_map_gzoom'] = '10';
  $_SESSION[QT]['m_map_gbuttons'] = 'P11100';
  $_SESSION[QT]['m_map_gfind'] = 'Brussels, Belgium';
  $_SESSION[QT]['m_map_gsymbol'] = '0'; // "icon_filename shadow_filename". 0=Default symbol with shadow
  $_SESSION[QT]['m_map_sections'] = 'U';  // "U,S,id" section id, U=userlist, S=search result
  $_SESSION[QT]['m_map_symbols'] = '0'; // symbols by user role (0=No symbols by userrole)
  $oDB->Query( 'DELETE FROM '.TABSETTING.' WHERE param="module_map" OR param="m_map_gkey" OR
  param="m_map_gcenter" OR param="m_map_gzoom" OR
  param="m_map_gbuttons" OR param="m_map_gfind" OR
  param="m_map_gsymbol" OR param="m_map_sections" OR param="m_map_symbols"' );
  $oDB->Query( 'INSERT INTO '.TABSETTING.' (param,setting) VALUES ("module_map","'.$_SESSION[QT]['module_map'].'")' );
  $oDB->Query( 'INSERT INTO '.TABSETTING.' (param,setting) VALUES ("m_map_gkey","'.$_SESSION[QT]['m_map_gkey'].'")' );
  $oDB->Query( 'INSERT INTO '.TABSETTING.' (param,setting) VALUES ("m_map_gcenter","'.$_SESSION[QT]['m_map_gcenter'].'")' );
  $oDB->Query( 'INSERT INTO '.TABSETTING.' (param,setting) VALUES ("m_map_gzoom","'.$_SESSION[QT]['m_map_gzoom'].'")' );
  $oDB->Query( 'INSERT INTO '.TABSETTING.' (param,setting) VALUES ("m_map_gbuttons","'.$_SESSION[QT]['m_map_gbuttons'].'")' );
  $oDB->Query( 'INSERT INTO '.TABSETTING.' (param,setting) VALUES ("m_map_gfind","'.$_SESSION[QT]['m_map_gfind'].'")' );
  $oDB->Query( 'INSERT INTO '.TABSETTING.' (param,setting) VALUES ("m_map_gsymbol","'.$_SESSION[QT]['m_map_gsymbol'].'")' );
  $oDB->Query( 'INSERT INTO '.TABSETTING.' (param,setting) VALUES ("m_map_sections","'.$_SESSION[QT]['m_map_sections'].'")' );
  $oDB->Query( 'INSERT INTO '.TABSETTING.' (param,setting) VALUES ("m_map_symbols","'.$_SESSION[QT]['m_map_symbols'].'")' );
}

// --------
// Html start
// --------
include 'qtf_adm_p_header.php';

echo '<h2>Checking components</h2>';
if ( !$bStep1 )
{
  echo '<p class="error">',$error,'</p>';
  include 'qtf_adm_p_footer.php';
  exit;
}
echo '<p>Ok</p>';
echo '<h2>Database settings</h2>';
if ( !$bStepZ )
{
  echo '<p class="error">',$error,'</p>';
  include 'qtf_adm_p_footer.php';
  exit;
}
echo '<p>Ok</p>';
echo '<h2>Installation completed</h2>';

if ( substr($_SESSION[QT]['version'],0,1)=='2' )
{
  echo '<p class="error">Your database version is 2.x. We recommand you to upgrade to 3.0 (use the installation wizard of QuickTalk).</p>';
}

// --------
// Html end
// --------