<?php

/* ============
 * qtf_map_lib.php
 * ------------
 * version: 3.0 build:20121228
 * This is a module library
 * ------------
 * QTgempty()
 * QTgmapscript()
 * QTgmappoints()
 * ============ */

class cMapPoint
{
  // Properties

  public $y = 4.352;
  public $x = 50.847;
  public $title = ''; // marker tips
  public $info = '';  // html to display on click
  public $icon = false;
  public $shadow = false;
  public $printicon = false;
  public $printshadow = false;

  // Class constructor

  function cMapPoint($y,$x,$title='',$info='')
  {
    if ( isset($y) && isset($x) )
    {
      $this->y = $y;
      $this->x = $x;
    }
    else
    {
      global $qtf_gcenter;
      if ( isset($qtf_gcenter) )
      {
      $this->y = floatval(QTgety($qtf_gcenter));
      $this->x = floatval(QTgetx($qtf_gcenter));
      }
    }
    if ( !empty($title) ) $this->title = $title;
    if ( !empty($info) ) $this->info = $info;
  }

  // Methods

  function MarkerWith($str='shadow')
  {
    if ( $str=='shadow' )     { if ( $this->icon && $this->shadow ) return 'true'; }
    if ( $str=='printicon' )  { if ( $this->icon && $this->printicon ) return 'true'; }
    if ( $str=='printshadow' ){ if ( $this->icon && $this->printshadow ) return 'true'; }
    return 'false';
  }
}

// Attention x,y,z MUST be FLOAT (or null) !
// If x,y,z are NULL or not float, these functions will returns FALSE.
// When entity (item) is created, the x,y,z are null (i.e. no point, no display)

// ---------

function QTgcanmap($strSection=null,$strRole='')
{
  // Check

  if ( !isset($strSection) ) die('QTgcanmap: arg #1 must be a section ref');
  if ( !is_string($strRole) ) die('QTgcanmap: arg #2 must be an string');

  // Check module

  if ( !isset($_SESSION[QT]['m_map_gkey']) ) return FALSE;
  if ( empty($_SESSION[QT]['m_map_gkey']) ) return FALSE;

  // Added 'U' section, if missing registrery
  if ( !isset($_SESSION[QT]['m_map_sections']) ) $_SESSION[QT]['m_map_sections'] = 'U';
  if ( !strstr($_SESSION[QT]['m_map_sections'],$strSection) ) return FALSE;

  // exit
  return TRUE;

}

// ---------

function QTgmapApi($strKey='',$strAddLibrary='')
{
  if ( empty($strKey) ) return '';
  return '<script type="text/javascript" src="https://maps.googleapis.com/maps/api/js?key='.$strKey.'&amp;sensor=false"></script>'.PHP_EOL.(empty($strAddLibrary) ? '' : $strAddLibrary);
}

// ---------

// QTgempty
// Return true when $i is empty or a value starting with '0.000000'

function QTgempty($i)
{
  if ( empty($i) ) return true;
  if ( !is_string($i) && !is_float($i) && !is_int($i) ) die('QTgempty: Invalid argument #1');
  if ( substr((string)$i,0,8)=='0.000000' ) return true;
  return false;
}

// ---------

function QTgmapMarker($centerLatLng='',$draggable=false,$gsymbol=false,$title='',$info='',$gshadow=false)
{
  if ( $centerLatLng==='' || $centerLatLng==='0,0' ) return 'marker = null;';
  if ( $centerLatLng=='map' )
  {
    $centerLatLng = 'map.getCenter()';
  }
  else
  {
    $centerLatLng = 'new google.maps.LatLng('.$centerLatLng.')';
  }
  if ( $draggable=='1' || $draggable==='true' || $draggable===true )
  {
  	$draggable='draggable:true, animation:google.maps.Animation.DROP,';
  }
  else
  {
  	$draggable='draggable:false,';
  }
  return '	marker = new google.maps.Marker({
		position: '.$centerLatLng.',
		map: map,
		' . $draggable . QTgmapMarkerIcon($gsymbol,$gshadow) . '
		title: qtHtmldecode("'.$title.'")
		});
		markers.push(marker); '.PHP_EOL.(empty($info) ? '' : '	gmapInfo(marker,\''.$info.'\');');
}

// ---------

function QTgmapMarkerIcon($gsymbol=false,$gshadow=false,$qtf_gprinticon=true,$qtf_gprintshadow=false)
{
  // returns the google.maps.Marker.icon argument (or nothing in case of default symbol)
  if ( empty($gsymbol) ) return '';
  $str = '';
  // icons are 32x32 pixels and the anchor depends on the name: (10,32) for puhspin, (16,32) for point, center form others
  $arr = explode('_',$gsymbol);
  switch($arr[0])
  {
    case 'pushpin':
      $str = 'icon: new google.maps.MarkerImage("qtfm_map/'.$gsymbol.'.png",new google.maps.Size(32,32),new google.maps.Point(0,0),new google.maps.Point(10,32)),';
      if ( $gshadow ) $str .= 'shadow: new google.maps.MarkerImage("qtfm_map/'.$gshadow .'.png",new google.maps.Size(59,32),new google.maps.Point(0,0),new google.maps.Point(10,32)),';
      break;
    case 'point':
     $str = 'icon: new google.maps.MarkerImage("qtfm_map/'.$gsymbol.'.png",new google.maps.Size(32,32),new google.maps.Point(0,0),new google.maps.Point(16,32)),';
      if ( $gshadow ) $str .= 'shadow: new google.maps.MarkerImage("qtfm_map/'.$gshadow .'.png",new google.maps.Size(59,32),new google.maps.Point(0,0),new google.maps.Point(16,32)),';
     break;
    default:
     $str = 'icon: new google.maps.MarkerImage("qtfm_map/'.$gsymbol.'.png",new google.maps.Size(32,32),new google.maps.Point(0,0),new google.maps.Point(16,16)),';
      if ( $gshadow ) $str .= 'shadow: new google.maps.MarkerImage("qtfm_map/'.$gshadow .'.png",new google.maps.Size(59,32),new google.maps.Point(0,0),new google.maps.Point(16,16)),';
     break;
  }
  return $str;
}

// ---------

function QTgmapMarkerMapTypeId($qtf_gbuttons)
{
  switch($qtf_gbuttons)
  {
	case 'S':
	case 'SATELLITE': return 'google.maps.MapTypeId.SATELLITE'; break;
	case 'H':
	case 'HYBRID': return 'google.maps.MapTypeId.HYBRID'; break;
	case 'P':
	case 'T':
	case 'TERRAIN': return 'google.maps.MapTypeId.TERRAIN'; break;
	default: return 'google.maps.MapTypeId.ROADMAP';
  }
}

// ---------

function QTgetx($str=null,$onerror=0.0)
{
  // checks
  if ( !is_string($str) ) { if ( isset($onerror) ) return $onerror; die('QTgetx: arg #1 must be a string'); }
  if ( !strstr($str,',') ) { { if ( isset($onerror) ) return $onerror; die('QTgetx: arg #1 must be a string with 2 values'); }}
  $arr = explode(',',$str);
  if ( count($arr)<2 ) { if ( isset($onerror) ) return $onerror; die('QTgetx: coordinate must include at least 2 values'); }
  $str = trim($arr[1]);
  if ( !is_numeric($str) ) { if ( isset($onerror) ) return $onerror; die('QTgetx: x-coordinate is not a float'); }
  return (float)$str;
}
function QTgety($str=null,$onerror=0.0)
{
  // checks
  if ( !is_string($str) ) { if ( isset($onerror) ) return $onerror; die('QTgety: arg #1 must be a string'); }
  if ( !strstr($str,',') ) { { if ( isset($onerror) ) return $onerror; die('QTgety: arg #1 must be a string with 2 values'); }}
  $arr = explode(',',$str);
  if ( count($arr)<2 ) { if ( isset($onerror) ) return $onerror; die('QTgety: coordinate must include at least 2 values'); }
  $str = trim($arr[0]);
  if ( !is_numeric($str) ) { if ( isset($onerror) ) return $onerror; die('QTgety: y-coordinate is not a float'); }
  return (float)$str;
}
function QTgetz($str=null,$onerror=0.0)
{
  // checks
  if ( !is_string($str) ) { if ( isset($onerror) ) return $onerror; die('QTgetz: arg #1 must be a string'); }
  if ( !strstr($str,',') ) { { if ( isset($onerror) ) return $onerror; die('QTgetz: arg #1 must be a string with at least 3 values'); }}
  $arr = explode(',',$str);
  if ( count($arr)<3 ) { if ( isset($onerror) ) return $onerror; die('QTgetz: coordinate must include at least 3 values'); }
  $str = trim($arr[2]);
  if ( !is_numeric($str) ) { if ( isset($onerror) ) return $onerror; die('QTgetz: z-coordinate is not a float'); }
  return (float)$str;
}
// ---------

function QTdd2dms($dd,$intDec=0)
{
  $dms_d = intval($dd);
  $dd_m = abs($dd - $dms_d);
  $dms_m_float = 60 * $dd_m;
  $dms_m = intval($dms_m_float);
  $dd_s = abs($dms_m_float - $dms_m);
  $dms_s = 60 * $dd_s;
  return $dms_d.'&#176;'.$dms_m.'&#039;'.round($dms_s,$intDec).'&quot;';
}