<?php

/**
* PHP version 5
*
* LICENSE: This source file is subject to version 3.0 of the PHP license
* that is available through the world-wide-web at the following URI:
* http://www.php.net/license. If you did not receive a copy of
* the PHP License and are unable to obtain it through the web, please
* send a note to license@php.net so we can mail you a copy immediately.
*
* @package    QuickTalk
* @author     Philippe Vandenberghe <info@qt-cute.org>
* @copyright  2012 The PHP Group
* @version    3.0 build:20121228
*/

session_start();
require_once 'bin/qtf_init.php';
if ( !isset($_SESSION[QT]['m_rss']) ) die($L['E_access']);
$oHtml->links['css'] = '<link rel="stylesheet" type="text/css" href="'.$_SESSION[QT]['skin_dir'].'/qtf_index.css" /><link rel="stylesheet" type="text/css" href="bin/css/qtf_print.css" media="print" />';

$arrConf = explode(' ',$_SESSION[QT]['m_rss_conf']);
$strUser = $arrConf[0];
$strForm = $arrConf[1];
$strSize = $arrConf[2];

if ( !$oVIP->user->CanView(($strUser=='V' ? 'V' : 'U')) ) die('Access denied');

// INITIALISE

include Translate('qtfm_rss.php');

$oVIP->selfurl = 'qtfm_rss.php';
$oVIP->selfname = $L['rss']['Rss'];

$strRssUrl = $_SESSION[QT]['site_url'].'/rss';

$arrDomains = GetDomains();

// --------
// HTML START
// --------

$arrSections = GetSections('V');
foreach($arrSections as $intS=>$arrSection)
{
  $oHtml->links[] = '<link rel="alternate" type="application/rss+xml" title="'.QTconv($arrSection['title'],'1').'" href="'.$strRssUrl.'/qtf_'.$strForm.'_'.$intS.'.xml"/>';
}

$oVIP->arrJava=null;
include 'qtf_p_header.php';

  // END IF NO DOMAIN
  if (count($arrDomains)==0)
  {
  echo '<h2>',$oVIP->selfname,'</h2>',PHP_EOL;
  echo '<p>',$L['rss']['E_nosection'],'</p>';
  include 'qtf_p_footer.php';
  exit;
  }

// TITLE & version
$str = '2.0';
if ( $strForm=='atom' ) $str='Atom';

echo '<h2>',$oVIP->selfname,'</h2>
<p>RSS ',$str,'</p>
';

// --------
// DOMAIN / SECTIONS
// --------

$intDom = 0;
$intSec = 0;
foreach($arrDomains as $intDomain=>$strDomain)
{

  $intDom++;
  $arrSections = GetSections('V',$intDomain);
  if ( count($arrSections)>0 )
  {
    echo '<!-- domain ',$intDomain,': ',$strDomain,' -->',PHP_EOL;
    echo '<table class="data_s">',PHP_EOL;
    echo '<tr class="data_s">';
    echo '<th>&nbsp;</th>';
    echo '<th>',$strDomain,'</th>';
    echo '<th>',$L['rss']['Url'],'</th>';
    echo '</tr>';

    // SHOW SECTIONS

    $strAlt='r1';

    foreach($arrSections as $s=>$arrSection)
    {
      $intSec++;
      $oSEC = new cSection($arrSection,true);
      echo '<tr class="data_s ',$strAlt,'">';
      echo '<td class="tdicon">'.AsImg($_SESSION[QT]['skin_dir'].'/ico_section_'.$oSEC->type.'_'.$oSEC->status.'.gif','F',$L['Ico_section_'.$oSEC->type.'_'.$oSEC->status],'ico ico_s').'</td>';
      echo '<td class="tdsection"><span class="section">',$oSEC->name,'</span><br/><span class="sectiondesc">',$oSEC->descr,'</span></td>';
      echo '<td>';
      echo '<p class="disabled" style="margin:3px 0 5px 0">',$strRssUrl,'/qtf_',$strForm,'_',$s,'.xml</p>';
      echo '<a href="http://fusion.google.com/add?feedurl=',$strRssUrl,'/qtf_2_',$s,'.xml"><img src="admin/rss_google.gif" width="50" height="14" style="vertical-align:bottom;border-width:0" alt="+Google" title="add to iGoogle"/></a> ';
      echo '<a href="http://add.my.yahoo.com/rss?url=',$strRssUrl,'/qtf_2_',$s,'.xml"><img src="admin/rss_yahoo.gif" width="50" height="14" style="vertical-align:bottom;border-width:0" alt="+Yahoo" title="add to my Yahoo"/></a> ';
      echo '<a href="http://www.netvibes.com/subscribe.php?url=',$strRssUrl,'/qtf_2_',$s,'.xml"><img src="admin/rss_netvibes.gif" width="50" height="14" style="vertical-align:bottom;border-width:0" alt="+Netvibes" title="add to my Netvibes"/></a> ';
      echo '<a href="http://www.wikio.fr/subscribe?url=',$strRssUrl,'/qtf_2_',$s,'.xml"><img src="admin/rss_wikio.gif" width="50" height="14" style="vertical-align:bottom;border-width:0" alt="+Wikio" title="add to my Wikio"/></a> ';
      echo '<a href="',$strRssUrl,'/qtf_',$strForm,'_',$s,'.xml"><img src="admin/rss.gif" width="34" height="14" style="vertical-align:bottom;border-width:0" alt="rss" title="syndication"/></a> ';
      echo '</td>';
      echo '</tr>';
      if ( $strAlt=='r1' ) { $strAlt='r2'; } else { $strAlt='r1'; }
    }

    echo '</table>',PHP_EOL;
    if ( $intDom<count($arrDomains) ) echo '<p class="dom_sep"></p>',PHP_EOL;
  }
}

// No public section

if ( $intSec==0 )
{
  echo '<p>',( $oVIP->user->role=='V' ? $L['E_no_public_section'] : $L['E_no_visible_section'] ),'</p>';
}

// HTML END

if (isset($oSEC)) unset($oSEC);
include 'qtf_p_footer.php';