<?php

/**
* PHP version 5
*
* LICENSE: This source file is subject to version 3.0 of the PHP license
* that is available through the world-wide-web at the following URI:
* http://www.php.net/license. If you did not receive a copy of
* the PHP License and are unable to obtain it through the web, please
* send a note to license@php.net so we can mail you a copy immediately.
*
* @package    QuickTalk
* @author     Philippe Vandenberghe <info@qt-cute.org>
* @copyright  2012 The PHP Group
* @version    3.0 build:20121228
*/

session_start();
require_once 'bin/qtf_init.php';
include Translate('qtf_adm.php');
include Translate('qtfm_rss.php');
if ( $oVIP->user->role!='A' ) die($L['E_admin']);

// INITIALISE

$oVIP->selfurl = 'qtfm_rss_adm.php';
$oVIP->selfname = $L['rss']['Admin'];
$strPageversion = $L['Version'].' 3.0';

// --------
// SUBMITTED
// --------

if ( isset($_POST['ok']) )
{
  // check others
  if ( empty($error) )
  {
    $_SESSION[QT]['m_rss'] = $_POST['rss'];
    $_SESSION[QT]['m_rss_conf'] = $_POST['rssuser'].' '.$_POST['rssformat'].' '.$_POST['rsssize'];
  }

  // save value
  if ( empty($error) )
  {
    $oDB->Query('UPDATE '.TABSETTING.' SET setting="'.$_SESSION[QT]['m_rss'].'" WHERE param="m_rss"');
    $oDB->Query('UPDATE '.TABSETTING.' SET setting="'.$_SESSION[QT]['m_rss_conf'].'" WHERE param="m_rss_conf"');
    // exit
    $_SESSION['pagedialog'] = (empty($error) ? 'O|'.$L['S_save'] : 'E|'.$error);
  }
}

// --------
// HTML START
// --------

include 'qtf_adm_p_header.php';

// read values
if ( !isset($_SESSION[QT]['m_rss_conf']) )
{
  $arr = GetParam(true,'param="m_rss_conf"');
  if ( empty($arr) ) die('<span class="error">Parameters not found. The module is probably not installed properly.</span><br/><br/><a href="qtf_adm_index.php">&laquo;&nbsp;'.$L['Exit'].'</a>');
}
if ( !isset($_SESSION[QT]['m_rss']) )
{
  $arr = GetParam(true,'param="m_rss"');
  if ( empty($arr) ) die('<span class="error">Parameters not found. The module is probably not installed properly.</span><br/><br/><a href="qtf_adm_index.php">&laquo;&nbsp;'.$L['Exit'].'</a>');
}

$arrConf = explode(' ',$_SESSION[QT]['m_rss_conf']);
$strUser = $arrConf[0];
$strForm = $arrConf[1];
$strSize = $arrConf[2];

// FORM

echo '
<form method="post" action="',$oVIP->selfurl,'">
<h2 class="subtitle">',$L['Status'],'</h2>
<table class="data_o">
<tr class="data_o">
<td class="headfirst">',$L['Status'],'</td>';
if ( $_SESSION[QT]['m_rss']=='1' )
{
  echo '<td style="width:100px;background-color:#AAFFAA;text-align:center">',$L['On_line'],'</td>';
}
else
{
  echo '<td style="width:100px;background-color:#FFAAAA;text-align:center">',$L['Off_line'],'</td>';
}
echo '<td style="text-align:right">',$L['Change'],'&nbsp;<select id="rss" name="rss">
<option value="1"',($_SESSION[QT]['m_rss']=='1' ? QSEL : ''),'>',$L['On_line'],'</option>
<option value="0"',($_SESSION[QT]['m_rss']=='0' ? QSEL : ''),'>',$L['Off_line'],'</option>
</select>
</td>
</tr>
</table>
';

echo '<h2 class="subtitle">',$L['Adm_settings'],'</h2>
<table class="data_o">
<tr class="data_o">
<td class="headfirst" style="width:200px"><label for="rssuser">',$L['rss']['User'],'</label></td>
<td><select id="rssuser" name="rssuser">
<option value="V"',($strUser=='V' ? QSEL : ''),'>',$L['rss']['All_users'],'</option>
<option value="U"',($strUser=='U' ? QSEL : ''),'>',$L['rss']['Members_only'],'</option>
</select></td>
<td><span class="help">',$L['rss']['H_User'],'</span></td>
</tr>
<tr class="data_o">
<td class="headfirst"><label for="rssformat">',$L['rss']['Format'],'</label></td>
<td><select id="rssformat" name="rssformat">
<option value="2"',($strForm=='2' ? QSEL : ''),'>RSS 2.0</option>
<option value="atom"',($strForm=='atom' ? QSEL : ''),'>Atom</option>
</select></td>
<td ><span class="help">',$L['rss']['H_Format'],'</span></td>
</tr>
<tr class="data_o">
<td class="headfirst"><label for="rsssize">',$L['rss']['Size'],'</label></td>
<td ><select id="rsssize" name="rsssize">
<option value="1"',($strSize=='1' ? QSEL : ''),'>1</option>
<option value="2"',($strSize=='2' ? QSEL : ''),'>2</option>
<option value="3"',($strSize=='3' ? QSEL : ''),'>3</option>
<option value="4"',($strSize=='4' ? QSEL : ''),'>4</option>
<option value="5"',($strSize=='5' ? QSEL : ''),'>5</option>
</select></td>
<td ><span class="help">',$L['rss']['H_Size'],'</span></td>
</tr>
</table>
';

echo '<p style="margin:0 0 5px 0;text-align:center"><input type="submit" name="ok" value="',$L['Save'],'"/></p>
</form>
';

$strRssUrl = $_SESSION[QT]['site_url'].'/rss';
$arrSections = GetSections('V');
$arrRss = array();
foreach($arrSections as $s=>$arrSection)
{
if ( file_exists('rss/qtf_'.$strForm.'_'.$s.'.xml') ) $arrRss[$s]=$strRssUrl.'/qtf_'.$strForm.'_'.$s.'.xml';
}

if ( count($arrRss)>0 )
{
  echo '<h2>',$L['Preview'],'</h2>',PHP_EOL;
  echo '<table class="data_t">',PHP_EOL;
  foreach($arrRss as $s=>$strRss)
  {
  echo '<tr class="data_t hover"><td >'.$arrSections[$s]['title'],'</td><td ><a class="small" href="',$strRss,'" target="_blank">',$strRss,'</a></td></tr>';
  }
  echo '</table>';
  echo '<p class="small">The feeds remain accessible when the module is off-line.</p>';
}

// HTML END

include 'qtf_adm_p_footer.php';